#! /bin/bash

RDIR=~/releases


if [ ! -d $RDIR ]; then
    if [ -a $RDIR ]; then
	echo "Release directory isn't a directory!"
	exit
    fi
    mkdir -p $RDIR
fi

version=`cat VERSION | perl -e "while (<STDIN>) {  if (m/(\d+\.\d+(.\d+)?)/) { print \\$1; } }"`
cvs=`cat VERSION | perl -e "while (<STDIN>) {  if (m/\d+\.\d+(.\d+)?.*(cvs|CVS|Cvs)/) { print 'cvs'; } }"`
if [ "$cvs" == "cvs" ]; then
    rname="mrses-`date +%y%m%d.%H%M%S`"
    lname="ppclibs-`date +%y%m%d.%H%M%S`"
else
    rname="mrses-$version";
    lname="ppclibs-$version";
fi
if [ -d $RDIR/$rname ]; then
    rm -rf $RDIR/$rname
fi
mkdir -p $RDIR/$rname
if [ ! -d $RDIR/$rname ]; then
    echo "Can't create directory!!!"
    exit
fi
cp -a * $RDIR/$rname
#cp -al * $RDIR/$rname

(
    cd $RDIR/$rname
    make clean -C cell
    rm -f cell/mrses_hw.mex*
    rm -f cell/spu/*.[od]

    if [ -a ../$lname.tar ]; then
	rm -f ../$lname.tar
    fi
    tar cf ../$lname.tar libs
    rm -rf libs
    
    cd ..

    if [ -a $rname.tar.bz2 ]; then
	rm -f $rname.tar.bz2
    fi
    tar cjf $rname.tar.bz2 $rname
    rm -rf $rname
#    scp $rname.tar.bz2 csa@crdcell:/home/csa/
#    ssh csa@crdcell /home/csa/mrses_install.sh $rname
)
